searchNodes=[{"doc":"A implementation of Jsonpath expression proposal by Stefan Goessner for Elixir. Warpath support dot–notation expression $.store.book[0].author or the bracket–notation $[&#39;store&#39;][&#39;book&#39;][0][&#39;author&#39;]. Operators OperatorDescription $The root element to query. This starts all path expressions. @The current node being processed by a filter predicate. *Wildcard. All objects/elements regardless their names. ..Deep scan, recursive descent. .nameDot-notated child, it support string or atom as keys. [&#39;name&#39;],[&quot;name&quot;]Bracket-notated child, it support string or atom as keys. [int (,int&gt;)]Array index or indexes [start:end:step]Array slice operator. Start index inclusive, end index exclusive. [?(expression)]Filter expression. Expression must evaluate to a boolean value. Filter operators Filter are expression that must be evaluated to a boolean value, Warpath will use then to retain data when filter a list, a filter expression have the syntax like this [?( @.category == &#39;fiction&#39; )]. All filter operator supported by Warpath have the same behavior of Elixir lang, it means that it&#39;s possible to compare different data types. The down side of this approach is that filter a list with different data types could result in undesired output, for example: iex&gt; data = [:atom, &quot;string&quot;, 11] ...&gt; Warpath.query(data, &quot;$[?(@ &gt; 10)]&quot;) {:ok, [:atom, &quot;string&quot;, 11]} The expression were evaluate and return the entirely input list as the output, this happen because the way elixir implement comparison, check the Elixir getting started page for more information. To cover this case Warpath support some functions to check the underline data type that the filter is operate on, it could be combined with and operator to gain the strictness among comparison. The above expression could be rewrite to retain only integer values that is greater than 10 like this. iex&gt; data = [:atom, &quot;string&quot;, 11] ...&gt; Warpath.query(data, &quot;$[?(@ &gt; 10 and is_integer(@))]&quot;) {:ok, [11]} OperatorDescription ==left is equal to right ===left is equal to right in strict mode !=left is not equal to right !==left is not equal to right in strict mode &lt;left is less than right &lt;=left is less or equal to right &gt;left is greater than right &gt;=left is greater than or equal to right inleft exists in right [?(@.price in [10, 20, 30])] and,&amp;&amp;logical and operator [?(@.price &gt; 50 and @.price &lt; 100)] or,&#124;&#124;logical or operator [?(@.category == &#39;fiction&#39; or @.price &lt; 100)] notlogical not operator [?(not @.category == &#39;fiction&#39;)] FunctionDescription is_atom/1check if the given expression argument is evaluate to atom is_binary/1check if the given expression argument is evaluate to binary is_boolean/1check if the given expression argument is evaluate to boolean is_float/1check if the given expression argument is evaluate to float is_integer/1check if the given expression argument is evaluate to integer is_list/1check if the given expression argument is evaluate to list is_map/1check if the given expression argument is evaluate to map is_nil/1check if the given expression argument is evaluate to nil is_number/1check if the given expression argument is evaluate to number is_tuple/1check if the given expression argument is evaluate to tuple Examples #Dot-notated access iex&gt;Warpath.query(%{&quot;category&quot; =&gt; &quot;fiction&quot;, &quot;price&quot; =&gt; 12.99}, &quot;$.category&quot;) {:ok, &quot;fiction&quot;} #Dot-notated using unicode as key iex&gt;Warpath.query(%{&quot;🌢&quot; =&gt; &quot;Elixir&quot;}, &quot;$.🌢&quot;) {:ok, &quot;Elixir&quot;} #Bracket-notated access iex&gt;Warpath.query(%{&quot;key with whitespace&quot; =&gt; &quot;some value&quot;}, &quot;$.[&#39;key with whitespace&#39;]&quot;) {:ok, &quot;some value&quot;} #atom based access iex&gt;Warpath.query(%{atom_key: &quot;some value&quot;}, &quot;$.:atom_key&quot;) {:ok, &quot;some value&quot;} #quoted atom iex&gt;Warpath.query(%{&quot;atom key&quot;: &quot;some value&quot;}, ~S{$.:&quot;atom key&quot;}) {:ok, &quot;some value&quot;} #wildcard access iex&gt;document = %{&quot;store&quot; =&gt; %{&quot;car&quot; =&gt; %{&quot;price&quot; =&gt; 100_000}, &quot;bicycle&quot; =&gt; %{&quot;price&quot; =&gt; 500}}} ...&gt;Warpath.query(document, &quot;$.store.*.price&quot;) {:ok, [500, 100_000]} #scan operator iex&gt;document = %{&quot;store&quot; =&gt; %{&quot;car&quot; =&gt; %{&quot;price&quot; =&gt; 100_000}, &quot;bicycle&quot; =&gt; %{&quot;price&quot; =&gt; 500}}} ...&gt;Warpath.query(document, &quot;$..price&quot;) {:ok, [500, 100_000]} #filter operator iex&gt;document = %{&quot;store&quot; =&gt; %{&quot;car&quot; =&gt; %{&quot;price&quot; =&gt; 100_000}, &quot;bicycle&quot; =&gt; %{&quot;price&quot; =&gt; 500}}} ...&gt; Warpath.query(document, &quot;$..*[?( @.price &gt; 500 and is_integer(@.price) )]&quot;) {:ok, [%{&quot;price&quot; =&gt; 100000}]} #contains filter operator iex&gt;document = %{&quot;store&quot; =&gt; %{&quot;car&quot; =&gt; %{&quot;price&quot; =&gt; 100_000}, &quot;bicyle&quot; =&gt; %{&quot;price&quot; =&gt; 500}}} ...&gt; Warpath.query(document, &quot;$..*[?(@.price)]&quot;) {:ok, [%{&quot;price&quot; =&gt; 500}, %{&quot;price&quot; =&gt; 100_000}]} #index access iex&gt;document = %{&quot;integers&quot; =&gt; [100, 200, 300]} ...&gt; Warpath.query(document, &quot;$.integers[0, 1]&quot;) {:ok, [100, 200]} iex&gt;document = %{&quot;integers&quot; =&gt; [100, 200, 300]} ...&gt; Warpath.query(document, &quot;$.integers[-1]&quot;) {:ok, 300} #wildcard as index access iex&gt;document = %{&quot;integers&quot; =&gt; [100, 200, 300]} ...&gt; Warpath.query(document, &quot;$.integers[*]&quot;) {:ok, [100, 200, 300]} #union iex&gt;document = %{&quot;key&quot; =&gt; &quot;value&quot;, &quot;another&quot; =&gt; &quot;entry&quot;} ...&gt; Warpath.query(document, &quot;$[&#39;key&#39;, &#39;another&#39;]&quot;) {:ok, [&quot;value&quot;, &quot;entry&quot;]} iex&gt; document = [0, 1, 2, 3, 4] ...&gt; Warpath.query(document, &quot;$[0,3]&quot;) {:ok, [0, 3]} #slice operator iex&gt; document = [0, 1, 2, 3, 4] ...&gt; Warpath.query(document, &quot;$[0:2:1]&quot;) {:ok, [0, 1]} #optional start and step iex&gt; document = [0, 1, 2, 3, 4] ...&gt; Warpath.query(document, &quot;$[:2]&quot;) {:ok, [0, 1]} #Negative index iex&gt; document = [0, 1, 2, 3, 4] ...&gt; Warpath.query(document, &quot;$[-2:]&quot;) {:ok, [3, 4]} #options iex&gt;document = %{&quot;integers&quot; =&gt; [100, 200, 300]} ...&gt; Warpath.query(document, &quot;$.integers[0, 1]&quot;, result_type: :path) {:ok, [&quot;$[&#39;integers&#39;][0]&quot;, &quot;$[&#39;integers&#39;][1]&quot;]} iex&gt;document = %{&quot;integers&quot; =&gt; [100, 200, 300]} ...&gt; Warpath.query(document, &quot;$.integers[0, 1]&quot;, result_type: :value_path) {:ok, [{100, &quot;$[&#39;integers&#39;][0]&quot;}, {200, &quot;$[&#39;integers&#39;][1]&quot;}]}","ref":"Warpath.html","title":"Warpath","type":"module"},{"doc":"Query data for the given expression. Example iex&gt; data_structure = %{&quot;name&quot; =&gt; &quot;Warpath&quot;} ...&gt; Warpath.query(data_structure, &quot;$.name&quot;) {:ok, &quot;Warpath&quot;} iex&gt; raw_json = ~s/{&quot;name&quot;: &quot;Warpath&quot;}/ ...&gt; Warpath.query(raw_json, &quot;$.name&quot;) {:ok, &quot;Warpath&quot;} iex&gt; #Pass a compiled expression as selector ...&gt; {:ok, expression} = Warpath.Expression.compile(&quot;$.autobots[0]&quot;) ...&gt; Warpath.query(%{&quot;autobots&quot; =&gt; [&quot;Optimus Prime&quot;, &quot;Warpath&quot;]}, expression) {:ok, &quot;Optimus Prime&quot;} Options: result_type: :value - return the value of evaluated expression - default :path - return the path of evaluated expression instead of it&#39;s value :value_path - return both value and path. :path_tokens - return the path tokens instead of it string representation, see Warpath.Element.Path. :value_path_tokens - return both value and path tokens.","ref":"Warpath.html#query/3","title":"Warpath.query/3","type":"function"},{"doc":"The same as query/3, but rise exception if it fail.","ref":"Warpath.html#query!/3","title":"Warpath.query!/3","type":"function"},{"doc":"","ref":"Warpath.html#t:document/0","title":"Warpath.document/0","type":"type"},{"doc":"","ref":"Warpath.html#t:json/0","title":"Warpath.json/0","type":"type"},{"doc":"","ref":"Warpath.html#t:opts/0","title":"Warpath.opts/0","type":"type"},{"doc":"","ref":"Warpath.html#t:selector/0","title":"Warpath.selector/0","type":"type"},{"doc":"This module contains functions to accumulate and transform item path tokens. The path are built during a expression evaluation by Warpath.query/3.","ref":"Warpath.Element.Path.html","title":"Warpath.Element.Path","type":"module"},{"doc":"Accumulate a path token into a path acc. Example iex&gt; acc = [{:root, &quot;$&quot;}] ...&gt; Warpath.Element.Path.accumulate({:property, &quot;name&quot;}, acc) [{:property, &quot;name&quot;}, {:root, &quot;$&quot;}]","ref":"Warpath.Element.Path.html#accumulate/2","title":"Warpath.Element.Path.accumulate/2","type":"function"},{"doc":"Transform path tokens into a jsonpath bracket-notation representation. Example iex&gt; acc = [{:property, &quot;name&quot;}, {:root, &quot;$&quot;}] ...&gt; Warpath.Element.Path.bracketify(acc) &quot;$[&#39;name&#39;]&quot;","ref":"Warpath.Element.Path.html#bracketify/1","title":"Warpath.Element.Path.bracketify/1","type":"function"},{"doc":"Transform path tokens into a jsonpath dot-notation representation. Example iex&gt; acc = [{:property, &quot;name&quot;}, {:root, &quot;$&quot;}] ...&gt; Warpath.Element.Path.dotify(acc) &quot;$.name&quot;","ref":"Warpath.Element.Path.html#dotify/1","title":"Warpath.Element.Path.dotify/1","type":"function"},{"doc":"","ref":"Warpath.Element.Path.html#t:acc/0","title":"Warpath.Element.Path.acc/0","type":"type"},{"doc":"","ref":"Warpath.Element.Path.html#t:token/0","title":"Warpath.Element.Path.token/0","type":"type"},{"doc":"This module contains functions to compile a jsonpath query string.","ref":"Warpath.Expression.html","title":"Warpath.Expression","type":"module"},{"doc":"Compile a jsonpath string query Example iex&gt; Warpath.Expression.compile(&quot;$.post.author&quot;) {:ok, %Warpath.Expression{tokens: [ {:root, &quot;$&quot;}, {:dot, {:property, &quot;post&quot;}}, {:dot, {:property, &quot;author&quot;}} ]}}","ref":"Warpath.Expression.html#compile/1","title":"Warpath.Expression.compile/1","type":"function"},{"doc":"Compiles jsonpath string query to expression. Examples iex&gt; import Warpath.Expression, only: [sigil_q: 2] iex&gt; ~q&quot;$.post.author&quot; %Warpath.Expression{tokens: [ {:root, &quot;$&quot;}, {:dot, {:property, &quot;post&quot;}}, {:dot, {:property, &quot;author&quot;}} ]}","ref":"Warpath.Expression.html#sigil_q/2","title":"Warpath.Expression.sigil_q/2","type":"macro"},{"doc":"","ref":"Warpath.Expression.html#t:array_slice/0","title":"Warpath.Expression.array_slice/0","type":"type"},{"doc":"","ref":"Warpath.Expression.html#t:dot_access/0","title":"Warpath.Expression.dot_access/0","type":"type"},{"doc":"","ref":"Warpath.Expression.html#t:filter/0","title":"Warpath.Expression.filter/0","type":"type"},{"doc":"","ref":"Warpath.Expression.html#t:fun/0","title":"Warpath.Expression.fun/0","type":"type"},{"doc":"","ref":"Warpath.Expression.html#t:has_property/0","title":"Warpath.Expression.has_property/0","type":"type"},{"doc":"","ref":"Warpath.Expression.html#t:index/0","title":"Warpath.Expression.index/0","type":"type"},{"doc":"","ref":"Warpath.Expression.html#t:indexes/0","title":"Warpath.Expression.indexes/0","type":"type"},{"doc":"","ref":"Warpath.Expression.html#t:operator/0","title":"Warpath.Expression.operator/0","type":"type"},{"doc":"","ref":"Warpath.Expression.html#t:property/0","title":"Warpath.Expression.property/0","type":"type"},{"doc":"","ref":"Warpath.Expression.html#t:root/0","title":"Warpath.Expression.root/0","type":"type"},{"doc":"","ref":"Warpath.Expression.html#t:scan/0","title":"Warpath.Expression.scan/0","type":"type"},{"doc":"","ref":"Warpath.Expression.html#t:t/0","title":"Warpath.Expression.t/0","type":"type"},{"doc":"","ref":"Warpath.Expression.html#t:token/0","title":"Warpath.Expression.token/0","type":"type"},{"doc":"","ref":"Warpath.Expression.html#t:union_property/0","title":"Warpath.Expression.union_property/0","type":"type"},{"doc":"","ref":"Warpath.Expression.html#t:wildcard/0","title":"Warpath.Expression.wildcard/0","type":"type"},{"doc":"","ref":"Warpath.Expression.ParserError.html","title":"Warpath.Expression.ParserError","type":"exception"},{"doc":"","ref":"Warpath.Expression.TokenizerError.html","title":"Warpath.Expression.TokenizerError","type":"exception"},{"doc":"","ref":"Warpath.ExpressionError.html","title":"Warpath.ExpressionError","type":"exception"},{"doc":"","ref":"Warpath.UnsupportedOperationError.html","title":"Warpath.UnsupportedOperationError","type":"exception"}]